" VIM Syntax file for txr
" Kaz Kylheku <kaz@kylheku.com>

" INSTALL-HOWTO:
"
" 1. Create the directory .vim/syntax in your home directory and
"    put the files txr.vim and tl.vim into this directory.
" 2. In your .vimrc, add this command to associate *.txr, *.tl and *.tlo
"    files with the txr and tl filetypes:
"    :au BufRead,BufNewFile *.txr set filetype=txr | set lisp
"    :au BufRead,BufNewFile *.tl,*.tlo set filetype=tl | set lisp
"
" If you want syntax highlighting to be on automatically (for any language)
" you need to add ":syntax on" in your .vimrc also. But you knew that already!
"
" This file is generated by the genvim.txr script in the TXR source tree.

syn case match
syn spell toplevel

setlocal iskeyword=a-z,A-Z,48-57,!,$,%,&,*,+,-,:,<,=,>,?,\\,_,~,/,^

syn keyword tl_keyword contained %e% %pi% * *args*
syn keyword tl_keyword contained *args-eff* *args-full* *filters* *full-args*
syn keyword tl_keyword contained *gensym-counter* *hash-seed* *lib-version* *listener-greedy-eval-p*
syn keyword tl_keyword contained *listener-hist-len* *listener-multi-line-p* *listener-pprint-p* *listener-sel-inclusive-p*
syn keyword tl_keyword contained *load-path* *package* *package-alist* *param-macro*
syn keyword tl_keyword contained *place-clobber-expander* *place-delete-expander* *place-macro* *place-update-expander*
syn keyword tl_keyword contained *pprint-flo-format* *print-base* *print-circle* *print-flo-digits*
syn keyword tl_keyword contained *print-flo-format* *print-flo-precision* *random-state* *random-warmup*
syn keyword tl_keyword contained *rec-source-loc* *stddebug* *stderr* *stdin*
syn keyword tl_keyword contained *stdlog* *stdnull* *stdout* *trace-output*
syn keyword tl_keyword contained *txr-version* *unhandled-hook* + -
syn keyword tl_keyword contained / /= : :abandoned
syn keyword tl_keyword contained :addr :apf :append :args
syn keyword tl_keyword contained :atime :auto :awk-again :awk-file
syn keyword tl_keyword contained :awk-rec :begin :begin-file :blksize
syn keyword tl_keyword contained :blocks :bool :byte-oriented :cdigit
syn keyword tl_keyword contained :chars :cint :close :continue
syn keyword tl_keyword contained :counter :cspace :ctime :cword-char
syn keyword tl_keyword contained :dec :decline :dev :digit
syn keyword tl_keyword contained :downcase :end :end-file :env
syn keyword tl_keyword contained :eql-based :equal-based :explicit-no :fallback
syn keyword tl_keyword contained :fd :fence :filter :fini
syn keyword tl_keyword contained :finish :float :form :from-current
syn keyword tl_keyword contained :from-end :from-start :from_html :frombase64
syn keyword tl_keyword contained :fromhtml :frompercent :fromurl :fun
syn keyword tl_keyword contained :function :gap :gid :greedy
syn keyword tl_keyword contained :hex :hextoint :inf :init
syn keyword tl_keyword contained :ino :inp :inputs :instance
syn keyword tl_keyword contained :into :key :let :lfilt
syn keyword tl_keyword contained :lines :list :lists :local
syn keyword tl_keyword contained :longest :mandatory :maxgap :maxtimes
syn keyword tl_keyword contained :method :mid :mingap :mintimes
syn keyword tl_keyword contained :mode :mtime :name :named
syn keyword tl_keyword contained :next-spec :nlink :nothrow :oct
syn keyword tl_keyword contained :outf :outp :output :postinit
syn keyword tl_keyword contained :prio :rdev :real-time :reflect
syn keyword tl_keyword contained :repeat-spec :resolve :rfilt :set
syn keyword tl_keyword contained :set-file :shortest :size :space
syn keyword tl_keyword contained :static :str :string :symacro
syn keyword tl_keyword contained :text :times :tlist :to_html
syn keyword tl_keyword contained :tobase64 :tofloat :tohtml :tohtml*
syn keyword tl_keyword contained :toint :tonumber :topercent :tourl
syn keyword tl_keyword contained :uid :upcase :use :use-from
syn keyword tl_keyword contained :use-syms :userdata :var :vars
syn keyword tl_keyword contained :weak-keys :weak-vals :whole :word-char
syn keyword tl_keyword contained :wrap < <= =
syn keyword tl_keyword contained > >= abort abs
syn keyword tl_keyword contained abs-path-p acons acons-new aconsql-new
syn keyword tl_keyword contained acos ado af-inet af-inet6
syn keyword tl_keyword contained af-unix af-unspec ai-addrconfig ai-all
syn keyword tl_keyword contained ai-canonname ai-numerichost ai-numericserv ai-passive
syn keyword tl_keyword contained ai-v4mapped alet align alignof
syn keyword tl_keyword contained alist-nremove alist-remove all allocate-struct
syn keyword tl_keyword contained and andf ap apf
syn keyword tl_keyword contained append append* append-each append-each*
syn keyword tl_keyword contained apply aret array arraysize
syn keyword tl_keyword contained ash asin assoc assql
syn keyword tl_keyword contained at-exit-call at-exit-do-not-call atan atan2
syn keyword tl_keyword contained atom awk base-name base64-decode
syn keyword tl_keyword contained base64-encode base64-stream-dec base64-stream-enc bchar
syn keyword tl_keyword contained be-double be-float be-int16 be-int32
syn keyword tl_keyword contained be-int64 be-uint16 be-uint32 be-uint64
syn keyword tl_keyword contained bignum-len bignump bindable bit
syn keyword tl_keyword contained blkcnt-t blksize-t block block*
syn keyword tl_keyword contained bool boundp bracket break-str
syn keyword tl_keyword contained brkint bs0 bs1 bsdly
syn keyword tl_keyword contained bstr bstr-d buf buf-alloc-size
syn keyword tl_keyword contained buf-carray buf-d buf-get-char buf-get-cptr
syn keyword tl_keyword contained buf-get-double buf-get-float buf-get-i16 buf-get-i32
syn keyword tl_keyword contained buf-get-i64 buf-get-i8 buf-get-int buf-get-long
syn keyword tl_keyword contained buf-get-short buf-get-u16 buf-get-u32 buf-get-u64
syn keyword tl_keyword contained buf-get-u8 buf-get-uchar buf-get-uint buf-get-ulong
syn keyword tl_keyword contained buf-get-ushort buf-put-char buf-put-cptr buf-put-double
syn keyword tl_keyword contained buf-put-float buf-put-i16 buf-put-i32 buf-put-i64
syn keyword tl_keyword contained buf-put-i8 buf-put-int buf-put-long buf-put-short
syn keyword tl_keyword contained buf-put-u16 buf-put-u32 buf-put-u64 buf-put-u8
syn keyword tl_keyword contained buf-put-uchar buf-put-uint buf-put-ulong buf-put-ushort
syn keyword tl_keyword contained buf-set-length buf-trim bufp build
syn keyword tl_keyword contained build-list butlast butlastn caaaaar
syn keyword tl_keyword contained caaaadr caaaar caaadar caaaddr
syn keyword tl_keyword contained caaadr caaar caadaar caadadr
syn keyword tl_keyword contained caadar caaddar caadddr caaddr
syn keyword tl_keyword contained caadr caar cadaaar cadaadr
syn keyword tl_keyword contained cadaar cadadar cadaddr cadadr
syn keyword tl_keyword contained cadar caddaar caddadr caddar
syn keyword tl_keyword contained cadddar caddddr cadddr caddr
syn keyword tl_keyword contained cadr call call-clobber-expander call-finalizers
syn keyword tl_keyword contained call-super-fun call-super-method call-update-expander callf
syn keyword tl_keyword contained car carray carray-blank carray-buf
syn keyword tl_keyword contained carray-buf-sync carray-cptr carray-dup carray-free
syn keyword tl_keyword contained carray-get carray-getz carray-list carray-num
syn keyword tl_keyword contained carray-own carray-pun carray-put carray-putz
syn keyword tl_keyword contained carray-ref carray-refset carray-replace carray-set-length
syn keyword tl_keyword contained carray-sub carray-type carray-unum carray-vec
syn keyword tl_keyword contained carrayp caseq caseq* caseql
syn keyword tl_keyword contained caseql* casequal casequal* cat-str
syn keyword tl_keyword contained cat-streams cat-vec catch catch*
syn keyword tl_keyword contained catch** catenated-stream-p catenated-stream-push cbaud
syn keyword tl_keyword contained cbaudex cdaaaar cdaaadr cdaaar
syn keyword tl_keyword contained cdaadar cdaaddr cdaadr cdaar
syn keyword tl_keyword contained cdadaar cdadadr cdadar cdaddar
syn keyword tl_keyword contained cdadddr cdaddr cdadr cdar
syn keyword tl_keyword contained cddaaar cddaadr cddaar cddadar
syn keyword tl_keyword contained cddaddr cddadr cddar cdddaar
syn keyword tl_keyword contained cdddadr cdddar cddddar cdddddr
syn keyword tl_keyword contained cddddr cdddr cddr cdr
syn keyword tl_keyword contained ceil ceil-rem chain chand
syn keyword tl_keyword contained char chdir chmod chr-digit
syn keyword tl_keyword contained chr-int chr-isalnum chr-isalpha chr-isascii
syn keyword tl_keyword contained chr-isblank chr-iscntrl chr-isdigit chr-isgraph
syn keyword tl_keyword contained chr-islower chr-isprint chr-ispunct chr-isspace
syn keyword tl_keyword contained chr-isunisp chr-isupper chr-isxdigit chr-num
syn keyword tl_keyword contained chr-str chr-str-set chr-tolower chr-toupper
syn keyword tl_keyword contained chr-xdigit chrp clamp clear-dirty
syn keyword tl_keyword contained clear-error clear-struct clearhash clocal
syn keyword tl_keyword contained clock-t clockid-t close close-stream
syn keyword tl_keyword contained closelog closure cmp-str cmspar
syn keyword tl_keyword contained collect-each collect-each* comb command-get
syn keyword tl_keyword contained command-get-buf command-get-lines command-get-string command-put
syn keyword tl_keyword contained command-put-buf command-put-lines command-put-string compile
syn keyword tl_keyword contained compile-defr-warning compile-error compile-file compile-only
syn keyword tl_keyword contained compile-toplevel compile-warning compl-span-str cond
syn keyword tl_keyword contained conda condlet cons conses
syn keyword tl_keyword contained conses* consp constantp copy
syn keyword tl_keyword contained copy-alist copy-buf copy-carray copy-cons
syn keyword tl_keyword contained copy-fun copy-hash copy-list copy-str
syn keyword tl_keyword contained copy-struct copy-vec cos count-if
syn keyword tl_keyword contained count-until-match countq countql countqual
syn keyword tl_keyword contained cptr cptr-cast cptr-free cptr-int
syn keyword tl_keyword contained cptr-null cptr-obj cptr-size-hint cptr-type
syn keyword tl_keyword contained cptr-zap cptrp cr0 cr1
syn keyword tl_keyword contained cr2 cr3 crdly cread
syn keyword tl_keyword contained crtscts crypt cs5 cs6
syn keyword tl_keyword contained cs7 cs8 csize cstopb
syn keyword tl_keyword contained cum-norm-dist daemon dec defer-warning
syn keyword tl_keyword contained defex deffi deffi-cb deffi-cb-unsafe
syn keyword tl_keyword contained deffi-sym deffi-type deffi-var define-accessor
syn keyword tl_keyword contained define-modify-macro define-param-expander define-place-macro defmacro
syn keyword tl_keyword contained defmeth defpackage defparm defparml
syn keyword tl_keyword contained defplace defset defstruct defsymacro
syn keyword tl_keyword contained defun defvar defvarl del
syn keyword tl_keyword contained delay delete-package dev-t diff
syn keyword tl_keyword contained digits digpow dir-name disassemble
syn keyword tl_keyword contained display-width divides dlclose dlopen
syn keyword tl_keyword contained dlsym dlsym-checked dlvsym dlvsym-checked
syn keyword tl_keyword contained do dohash doloop doloop*
syn keyword tl_keyword contained dotimes double downcase-str drop
syn keyword tl_keyword contained drop-until drop-while dump-compiled-objects dump-deferred-warnings
syn keyword tl_keyword contained dump-to-tlo dup dupfd dwim
syn keyword tl_keyword contained e2big eacces each each*
syn keyword tl_keyword contained eaddrinuse eaddrnotavail eafnosupport eagain
syn keyword tl_keyword contained ealready ebadf ebadmsg ebusy
syn keyword tl_keyword contained ecanceled echild echo echoctl
syn keyword tl_keyword contained echoe echok echoke echonl
syn keyword tl_keyword contained echoprt econnaborted econnrefused econnreset
syn keyword tl_keyword contained edeadlk edestaddrreq edom edquot
syn keyword tl_keyword contained eexist efault efbig ehostunreach
syn keyword tl_keyword contained eidrm eighth eilseq einprogress
syn keyword tl_keyword contained eintr einval eio eisconn
syn keyword tl_keyword contained eisdir elemsize elemtype eloop
syn keyword tl_keyword contained emfile emlink empty emsgsize
syn keyword tl_keyword contained emultihop enametoolong endgrent endp
syn keyword tl_keyword contained endpwent ends-with enetdown enetreset
syn keyword tl_keyword contained enetunreach enfile enobufs enodata
syn keyword tl_keyword contained enodev enoent enoexec enolck
syn keyword tl_keyword contained enolink enomem enomsg enoprotoopt
syn keyword tl_keyword contained enospc enosr enostr enosys
syn keyword tl_keyword contained enotconn enotdir enotempty enotrecoverable
syn keyword tl_keyword contained enotsock enotsup enotty ensure-dir
syn keyword tl_keyword contained enum enumed env env-fbind
syn keyword tl_keyword contained env-fbindings env-hash env-next env-vbind
syn keyword tl_keyword contained env-vbindings enxio eopnotsupp eoverflow
syn keyword tl_keyword contained eownerdead eperm epipe eproto
syn keyword tl_keyword contained eprotonosupport eprototype eq eql
syn keyword tl_keyword contained equal equot erange erofs
syn keyword tl_keyword contained errno error espipe esrch
syn keyword tl_keyword contained estale etime etimedout etxtbsy
syn keyword tl_keyword contained eval eval-only evenp ewouldblock
syn keyword tl_keyword contained exception-subtype-map exception-subtype-p exdev exec
syn keyword tl_keyword contained exit exit* exp expand
syn keyword tl_keyword contained expand* expand-left expand-right expand-with-free-refs
syn keyword tl_keyword contained expt exptmod extproc f$
syn keyword tl_keyword contained f-dupfd f-dupfd-cloexec f-getfd f-getfl
syn keyword tl_keyword contained f-getlk f-rdlck f-setfd f-setfl
syn keyword tl_keyword contained f-setlk f-setlkw f-unlck f-wrlck
syn keyword tl_keyword contained f^ f^$ false fboundp
syn keyword tl_keyword contained fcntl fd-cloexec ff0 ff1
syn keyword tl_keyword contained ffdly ffi ffi-alignof ffi-arraysize
syn keyword tl_keyword contained ffi-call ffi-elemsize ffi-elemtype ffi-get
syn keyword tl_keyword contained ffi-in ffi-make-call-desc ffi-make-closure ffi-offsetof
syn keyword tl_keyword contained ffi-out ffi-put ffi-put-into ffi-size
syn keyword tl_keyword contained ffi-type-compile ffi-type-operator-p ffi-type-p ffi-typedef
syn keyword tl_keyword contained fifth file-append file-append-buf file-append-lines
syn keyword tl_keyword contained file-append-string file-get file-get-buf file-get-lines
syn keyword tl_keyword contained file-get-string file-put file-put-buf file-put-lines
syn keyword tl_keyword contained file-put-string fileno fill-buf fill-buf-adjust
syn keyword tl_keyword contained fill-carray fill-obj filter-equal filter-string-tree
syn keyword tl_keyword contained finalize find find-frame find-frames
syn keyword tl_keyword contained find-frames-by-mask find-if find-max find-min
syn keyword tl_keyword contained find-package find-struct-type first fixnum-max
syn keyword tl_keyword contained fixnum-min fixnump flatcar flatcar*
syn keyword tl_keyword contained flatten flatten* flet flip
syn keyword tl_keyword contained flipargs flo-dig flo-down flo-epsilon
syn keyword tl_keyword contained flo-get-round-mode flo-int flo-max flo-max-dig
syn keyword tl_keyword contained flo-min flo-near flo-set-round-mode flo-str
syn keyword tl_keyword contained flo-up flo-zero float floatp
syn keyword tl_keyword contained floor floor-rem flush-stream flusho
syn keyword tl_keyword contained fmakunbound fmt fnm-casefold fnm-leading-dir
syn keyword tl_keyword contained fnm-noescape fnm-pathname fnm-period fnmatch
syn keyword tl_keyword contained for for* force force-break
syn keyword tl_keyword contained fork format fourth fr$
syn keyword tl_keyword contained fr^ fr^$ from frr
syn keyword tl_keyword contained fsblkcnt-t fsfilcnt-t fstat ftw
syn keyword tl_keyword contained ftw-actionretval ftw-chdir ftw-continue ftw-d
syn keyword tl_keyword contained ftw-depth ftw-dnr ftw-dp ftw-f
syn keyword tl_keyword contained ftw-mount ftw-ns ftw-phys ftw-skip-siblings
syn keyword tl_keyword contained ftw-skip-subtree ftw-sl ftw-sln ftw-stop
syn keyword tl_keyword contained fun func-get-env func-get-form func-get-name
syn keyword tl_keyword contained func-set-env functionp gcd gen
syn keyword tl_keyword contained gen-hash-seed generate gensym gequal
syn keyword tl_keyword contained get-buf-from-stream get-byte get-char get-clobber-expander
syn keyword tl_keyword contained get-delete-expander get-error get-error-str get-frames
syn keyword tl_keyword contained get-hash-userdata get-indent get-indent-mode get-line
syn keyword tl_keyword contained get-lines get-list-from-stream get-obj get-sig-handler
syn keyword tl_keyword contained get-string get-string-from-stream get-update-expander getaddrinfo
syn keyword tl_keyword contained getegid getenv geteuid getgid
syn keyword tl_keyword contained getgrent getgrgid getgrnam getgroups
syn keyword tl_keyword contained gethash getitimer getopts getpid
syn keyword tl_keyword contained getppid getpwent getpwnam getpwuid
syn keyword tl_keyword contained getresgid getresuid getuid gid-t
syn keyword tl_keyword contained ginterate giterate glob glob-altdirfunc
syn keyword tl_keyword contained glob-brace glob-err glob-mark glob-nocheck
syn keyword tl_keyword contained glob-noescape glob-nomagic glob-nosort glob-onlydir
syn keyword tl_keyword contained glob-period glob-tilde glob-tilde-check go
syn keyword tl_keyword contained grade greater group-by group-reduce
syn keyword tl_keyword contained gun handle handle* handler-bind
syn keyword tl_keyword contained hash hash-alist hash-begin hash-construct
syn keyword tl_keyword contained hash-count hash-diff hash-eql hash-equal
syn keyword tl_keyword contained hash-from-alist hash-from-pairs hash-isec hash-keys
syn keyword tl_keyword contained hash-list hash-next hash-pairs hash-proper-subset
syn keyword tl_keyword contained hash-revget hash-subset hash-symdiff hash-uni
syn keyword tl_keyword contained hash-update hash-update-1 hash-userdata hash-values
syn keyword tl_keyword contained hashp have hlet hlet*
syn keyword tl_keyword contained html-decode html-encode html-encode* hupcl
syn keyword tl_keyword contained iapply icanon icrnl id-t
syn keyword tl_keyword contained identity ido iexten if
syn keyword tl_keyword contained ifa iff iffi iflet
syn keyword tl_keyword contained ignbrk igncr ignerr ignpar
syn keyword tl_keyword contained ignwarn imaxbel improper-plist-to-alist in
syn keyword tl_keyword contained in-package in-range in-range* in6addr-any
syn keyword tl_keyword contained in6addr-loopback inaddr-any inaddr-loopback inc
syn keyword tl_keyword contained inc-indent indent-code indent-data indent-foff
syn keyword tl_keyword contained indent-off inhash inlcr ino-t
syn keyword tl_keyword contained inpck int int-chr int-cptr
syn keyword tl_keyword contained int-flo int-ptr-t int-str int16
syn keyword tl_keyword contained int32 int64 int8 integerp
syn keyword tl_keyword contained intern interp-fun-p interpose inv-cum-norm
syn keyword tl_keyword contained invoke-catch ip ipf iread
syn keyword tl_keyword contained isec isig isqrt istrip
syn keyword tl_keyword contained itimer-prov itimer-real itimer-virtual iuclc
syn keyword tl_keyword contained iutf8 ixany ixoff ixon
syn keyword tl_keyword contained juxt keep-if keep-if* keepq
syn keyword tl_keyword contained keepql keepqual key-t keyword-package
syn keyword tl_keyword contained keywordp kill labels lambda
syn keyword tl_keyword contained last lazy-str lazy-str-force lazy-str-force-upto
syn keyword tl_keyword contained lazy-str-get-trailing-list lazy-stream-cons lazy-stringp lcm
syn keyword tl_keyword contained lcons lcons-car lcons-cdr lcons-fun
syn keyword tl_keyword contained lconsp ldiff le-double le-float
syn keyword tl_keyword contained le-int16 le-int32 le-int64 le-uint16
syn keyword tl_keyword contained le-uint32 le-uint64 len length
syn keyword tl_keyword contained length-buf length-carray length-list length-str
syn keyword tl_keyword contained length-str-< length-str-<= length-str-> length-str->=
syn keyword tl_keyword contained length-vec lequal less let
syn keyword tl_keyword contained let* lexical-fun-p lexical-lisp1-binding lexical-var-p
syn keyword tl_keyword contained lib-version link lisp-parse list
syn keyword tl_keyword contained list* list-carray list-str list-vec
syn keyword tl_keyword contained list-vector listp lnew lnew*
syn keyword tl_keyword contained load load-for load-time loff-t
syn keyword tl_keyword contained log log-alert log-auth log-authpriv
syn keyword tl_keyword contained log-cons log-crit log-daemon log-debug
syn keyword tl_keyword contained log-emerg log-err log-info log-ndelay
syn keyword tl_keyword contained log-notice log-nowait log-odelay log-perror
syn keyword tl_keyword contained log-pid log-user log-warning log10
syn keyword tl_keyword contained log2 logand logcount logior
syn keyword tl_keyword contained lognot logtest logtrunc logxor
syn keyword tl_keyword contained long longlong lop lset
syn keyword tl_keyword contained lstat m$ m^ m^$
syn keyword tl_keyword contained mac-param-bind macro-ancestor macro-form-p macro-time
syn keyword tl_keyword contained macroexpand macroexpand-1 macroexpand-1-lisp1 macroexpand-lisp1
syn keyword tl_keyword contained macrolet major make-buf make-buf-stream
syn keyword tl_keyword contained make-catenated-stream make-env make-hash make-lazy-cons
syn keyword tl_keyword contained make-lazy-struct make-like make-package make-random-state
syn keyword tl_keyword contained make-similar-hash make-string-byte-input-stream make-string-input-stream make-string-output-stream
syn keyword tl_keyword contained make-strlist-input-stream make-strlist-output-stream make-struct make-struct-delegate-stream
syn keyword tl_keyword contained make-struct-type make-sym make-time make-time-utc
syn keyword tl_keyword contained make-trie make-union make-zstruct makedev
syn keyword tl_keyword contained makunbound mapcar mapcar* mapdo
syn keyword tl_keyword contained mapf maphash mappend mappend*
syn keyword tl_keyword contained maprend maprod mask match-fun
syn keyword tl_keyword contained match-regex match-regex-right match-regst match-regst-right
syn keyword tl_keyword contained match-str match-str-tree max mboundp
syn keyword tl_keyword contained member member-if memp memq
syn keyword tl_keyword contained memql memqual merge meth
syn keyword tl_keyword contained method min minor minusp
syn keyword tl_keyword contained mismatch mkdir mknod mkstring
syn keyword tl_keyword contained mlet mmakunbound mod mode-t
syn keyword tl_keyword contained multi multi-sort n-choose-k n-perm-k
syn keyword tl_keyword contained nconc neg neq neql
syn keyword tl_keyword contained nequal new new* nexpand-left
syn keyword tl_keyword contained nil nilf ninth nl0
syn keyword tl_keyword contained nl1 nldly nlink-t noflsh
syn keyword tl_keyword contained none not notf nreconc
syn keyword tl_keyword contained nreverse nth nthcdr nthlast
syn keyword tl_keyword contained null nullify num-carray num-chr
syn keyword tl_keyword contained num-str numberp nzerop o-accmode
syn keyword tl_keyword contained o-append o-async o-cloexec o-creat
syn keyword tl_keyword contained o-direct o-directory o-noatime o-noctty
syn keyword tl_keyword contained o-nofollow o-nonblock o-path o-rdonly
syn keyword tl_keyword contained o-rdwr o-sync o-trunc o-wronly
syn keyword tl_keyword contained oand obtain obtain* obtain*-block
syn keyword tl_keyword contained obtain-block ocrnl oddp ofdel
syn keyword tl_keyword contained off-t offsetof ofill olcuc
syn keyword tl_keyword contained onlcr onlret onocr op
syn keyword tl_keyword contained open-command open-directory open-file open-fileno
syn keyword tl_keyword contained open-files open-files* open-pipe open-process
syn keyword tl_keyword contained open-socket open-socket-pair open-tail openlog
syn keyword tl_keyword contained opip opost opt opthelp
syn keyword tl_keyword contained or orf package-alist package-fallback-list
syn keyword tl_keyword contained package-foreign-symbols package-local-symbols package-name package-symbols
syn keyword tl_keyword contained packagep pad parenb parmrk
syn keyword tl_keyword contained parodd partition partition* partition-by
syn keyword tl_keyword contained path-blkdev-p path-cat path-chrdev-p path-dir-p
syn keyword tl_keyword contained path-executable-to-me-p path-exists-p path-file-p path-mine-p
syn keyword tl_keyword contained path-my-group-p path-newer path-older path-pipe-p
syn keyword tl_keyword contained path-private-to-me-p path-read-writable-to-me-p path-readable-to-me-p path-same-object
syn keyword tl_keyword contained path-sep-chars path-setgid-p path-setuid-p path-sock-p
syn keyword tl_keyword contained path-sticky-p path-strictly-private-to-me-p path-symlink-p path-writable-to-me-p
syn keyword tl_keyword contained pdec pendin perm pid-t
syn keyword tl_keyword contained pinc pipe place-form-p placelet
syn keyword tl_keyword contained placelet* plist-to-alist plusp poll
syn keyword tl_keyword contained poll-err poll-in poll-nval poll-out
syn keyword tl_keyword contained poll-pri poll-rdband poll-rdhup poll-wrband
syn keyword tl_keyword contained poly pop pos pos-if
syn keyword tl_keyword contained pos-max pos-min posq posql
syn keyword tl_keyword contained posqual pppred ppred pprinl
syn keyword tl_keyword contained pprint pprof pred prinl
syn keyword tl_keyword contained print prod prof prog
syn keyword tl_keyword contained prog* prog1 progn promisep
syn keyword tl_keyword contained prop proper-list-p proper-listp pset
syn keyword tl_keyword contained ptr ptr-in ptr-in-d ptr-out
syn keyword tl_keyword contained ptr-out-d ptr-out-s ptrdiff-t pub:txr-sym
syn keyword tl_keyword contained pure-rel-path-p purge-deferred-warning push pushhash
syn keyword tl_keyword contained pushnew put-buf put-byte put-carray
syn keyword tl_keyword contained put-char put-line put-lines put-obj
syn keyword tl_keyword contained put-string put-strings pwd qquote
syn keyword tl_keyword contained qref quote r$ r^
syn keyword tl_keyword contained r^$ raise rand random
syn keyword tl_keyword contained random-fixnum random-float random-state-get-vec random-state-p
syn keyword tl_keyword contained range range* range-regex rangep
syn keyword tl_keyword contained rassoc rassql rcomb rcons
syn keyword tl_keyword contained read read-until-match readlink real-time-stream-p
syn keyword tl_keyword contained realpath record-adapter reduce-left reduce-right
syn keyword tl_keyword contained ref refset regex-compile regex-from-trie
syn keyword tl_keyword contained regex-parse regex-prefix-match regex-source regexp
syn keyword tl_keyword contained register-exception-subtypes register-tentative-def regsub rehome-sym
syn keyword tl_keyword contained relate release-deferred-warnings remhash remove-if
syn keyword tl_keyword contained remove-if* remove-path remq remq*
syn keyword tl_keyword contained remql remql* remqual remqual*
syn keyword tl_keyword contained rename-path repeat replace replace-list
syn keyword tl_keyword contained replace-str replace-struct replace-vec reset-struct
syn keyword tl_keyword contained rest ret retf return
syn keyword tl_keyword contained return* return-from revappend reverse
syn keyword tl_keyword contained rfind rfind-if rlcp rlcp-tree
syn keyword tl_keyword contained rlet rlist rlist* rmember
syn keyword tl_keyword contained rmember-if rmemq rmemql rmemqual
syn keyword tl_keyword contained rmismatch rotate round round-rem
syn keyword tl_keyword contained rperm rplaca rplacd rpoly
syn keyword tl_keyword contained rpos rpos-if rposq rposql
syn keyword tl_keyword contained rposqual rr rra rsearch
syn keyword tl_keyword contained rslot rtld-deepbind rtld-global rtld-lazy
syn keyword tl_keyword contained rtld-local rtld-nodelete rtld-noload rtld-now
syn keyword tl_keyword contained run s-ifblk s-ifchr s-ifdir
syn keyword tl_keyword contained s-ififo s-iflnk s-ifmt s-ifreg
syn keyword tl_keyword contained s-ifsock s-irgrp s-iroth s-irusr
syn keyword tl_keyword contained s-irwxg s-irwxo s-irwxu s-isgid
syn keyword tl_keyword contained s-isuid s-isvtx s-iwgrp s-iwoth
syn keyword tl_keyword contained s-iwusr s-ixgrp s-ixoth s-ixusr
syn keyword tl_keyword contained save-exe sbit scan-until-match search
syn keyword tl_keyword contained search-regex search-regst search-str search-str-tree
syn keyword tl_keyword contained second seek-cur seek-end seek-set
syn keyword tl_keyword contained seek-stream select self-load-path self-path
syn keyword tl_keyword contained seq-begin seq-next seq-reset seqp
syn keyword tl_keyword contained set set-diff set-hash-userdata set-indent
syn keyword tl_keyword contained set-indent-mode set-max-depth set-max-length set-package-fallback-list
syn keyword tl_keyword contained set-sig-handler setegid setenv seteuid
syn keyword tl_keyword contained setgid setgrent setgroups sethash
syn keyword tl_keyword contained setitimer setlogmask setpwent setresgid
syn keyword tl_keyword contained setresuid setuid seventh sh
syn keyword tl_keyword contained shift short shuffle sig-abrt
syn keyword tl_keyword contained sig-alrm sig-atomic-t sig-bus sig-check
syn keyword tl_keyword contained sig-chld sig-cont sig-fpe sig-hup
syn keyword tl_keyword contained sig-ill sig-int sig-io sig-iot
syn keyword tl_keyword contained sig-kill sig-pipe sig-poll sig-prof
syn keyword tl_keyword contained sig-pwr sig-quit sig-segv sig-stkflt
syn keyword tl_keyword contained sig-stop sig-sys sig-term sig-trap
syn keyword tl_keyword contained sig-tstp sig-ttin sig-ttou sig-urg
syn keyword tl_keyword contained sig-usr1 sig-usr2 sig-vtalrm sig-winch
syn keyword tl_keyword contained sig-xcpu sig-xfsz sign-extend signum
syn keyword tl_keyword contained sin sixth size-t size-vec
syn keyword tl_keyword contained sizeof slet slot slotp
syn keyword tl_keyword contained slots slotset sock-accept sock-bind
syn keyword tl_keyword contained sock-cloexec sock-connect sock-dgram sock-family
syn keyword tl_keyword contained sock-listen sock-nonblock sock-peer sock-recv-timeout
syn keyword tl_keyword contained sock-send-timeout sock-set-peer sock-shutdown sock-stream
syn keyword tl_keyword contained sock-type some sort sort-group
syn keyword tl_keyword contained source-loc source-loc-str span-str special-operator-p
syn keyword tl_keyword contained special-var-p spl splice split
syn keyword tl_keyword contained split* split-str split-str-set sqrt
syn keyword tl_keyword contained square ssize-t sssucc ssucc
syn keyword tl_keyword contained starts-with stat static-slot static-slot-ensure
syn keyword tl_keyword contained static-slot-home static-slot-p static-slot-set stdlib
syn keyword tl_keyword contained str str-d str-in6addr str-in6addr-net
syn keyword tl_keyword contained str-inaddr str-inaddr-net str< str<=
syn keyword tl_keyword contained str= str> str>= stream-get-prop
syn keyword tl_keyword contained stream-set-prop streamp string-extend string-lt
syn keyword tl_keyword contained stringp struct struct-from-args struct-from-plist
syn keyword tl_keyword contained struct-get-initfun struct-get-postinitfun struct-set-initfun struct-set-postinitfun
syn keyword tl_keyword contained struct-type struct-type-name struct-type-p structp
syn keyword tl_keyword contained sub sub-list sub-str sub-vec
syn keyword tl_keyword contained subtypep succ sum super
syn keyword tl_keyword contained super-method suspend swap symacrolet
syn keyword tl_keyword contained symbol-function symbol-macro symbol-name symbol-package
syn keyword tl_keyword contained symbol-value symbolp symdiff symlink
syn keyword tl_keyword contained sys:%backpatch-high16% sys:%backpatch-low16% sys:%big-endian% sys:%bin-op%
syn keyword tl_keyword contained sys:%bin-ops% sys:%block-using-funs% sys:%call-op% sys:%dbg-command-env%
syn keyword tl_keyword contained sys:%file-suff-rx% sys:%gcall-op% sys:%imm-width% sys:%lev-bits%
syn keyword tl_keyword contained sys:%lev-size% sys:%max-lev% sys:%max-lev-idx% sys:%max-sm-lev%
syn keyword tl_keyword contained sys:%max-sm-lev-idx% sys:%max-v-lev% sys:%nary-ops% sys:%oc-code%
syn keyword tl_keyword contained sys:%oc-hash% sys:%oc-list-builder% sys:%package-manip% sys:%sm-lev-bits%
syn keyword tl_keyword contained sys:%sm-lev-size% sys:%test-funs% sys:%test-funs-neg% sys:%test-funs-ops%
syn keyword tl_keyword contained sys:%test-funs-pos% sys:%test-inv% sys:%test-opcode% sys:%tlo-ver%
syn keyword tl_keyword contained sys:*dedup* sys:*emit* sys:*eval* sys:*load-recursive*
syn keyword tl_keyword contained sys:*op-ctx* sys:*pl-env* sys:*trace-hash* sys:*trace-level*
syn keyword tl_keyword contained sys:abscond* sys:abscond-from sys:analyze-argtypes sys:analyze-params
syn keyword tl_keyword contained sys:apply sys:asm-error sys:assumed-fun sys:awk%--rng
syn keyword tl_keyword contained sys:awk%--rng+ sys:awk%--rng- sys:awk%-rng+ sys:awk%rng+
syn keyword tl_keyword contained sys:awk-code-move-check sys:awk-error sys:awk-expander sys:awk-fun-let
syn keyword tl_keyword contained sys:awk-fun-shadowing-env sys:awk-mac-let sys:awk-redir sys:awk-test
syn keyword tl_keyword contained sys:b* sys:b+ sys:b- sys:b/
syn keyword tl_keyword contained sys:b< sys:b<= sys:b= sys:b=>
syn keyword tl_keyword contained sys:b> sys:bad-slot-syntax sys:bind-mac-check sys:bind-mac-error
syn keyword tl_keyword contained sys:bits sys:bits-to-obj sys:build-key-list sys:call-delete-expander
syn keyword tl_keyword contained sys:capture-cont sys:catch sys:check-slot sys:check-struct
syn keyword tl_keyword contained sys:circref sys:compare-swap sys:compat sys:compile-in-toplevel
syn keyword tl_keyword contained sys:compiler-emit-warnings sys:conv sys:conv-expand sys:conv-let
syn keyword tl_keyword contained sys:ctx-form sys:ctx-name sys:dbg-all sys:dbg-backtrace
syn keyword tl_keyword contained sys:dbg-clear sys:dbg-enable sys:dbg-restore sys:dbg-set
syn keyword tl_keyword contained sys:dbg-step sys:debugger sys:dedup sys:deffi-cb-expander
syn keyword tl_keyword contained sys:define-method sys:defopcode sys:defopcode-derived sys:defset-expander
syn keyword tl_keyword contained sys:defset-expander-simple sys:disassemble-cdf sys:dlib-expr sys:do-conv
syn keyword tl_keyword contained sys:do-path-test sys:dvbind sys:dwim-del sys:dwim-set
syn keyword tl_keyword contained sys:each-op sys:enc-small-op sys:ensure-op-arg sys:env-to-let
syn keyword tl_keyword contained sys:eval-err sys:expand-bind-mac-params sys:expand-defmacro sys:expand-defsymacro
syn keyword tl_keyword contained sys:expand-defun sys:expand-defvarl sys:expand-dohash sys:expand-doloop
syn keyword tl_keyword contained sys:expand-each sys:expand-handle sys:expand-params sys:expand-quasi
syn keyword tl_keyword contained sys:expand-quasi-args sys:expand-quasi-mods sys:expand-sym-ref sys:expr
syn keyword tl_keyword contained sys:extract-keys sys:extract-keys-p sys:fbind sys:fmt-flex
syn keyword tl_keyword contained sys:fmt-join sys:fmt-simple sys:for-op sys:gc
syn keyword tl_keyword contained sys:gc-set-delta sys:get-buf-common sys:get-fun-getter-setter sys:get-mb
syn keyword tl_keyword contained sys:get-parser sys:get-place-macro sys:get-vb sys:getopts-error
syn keyword tl_keyword contained sys:handle-bad-syntax sys:hlet-expand sys:if-to-cond sys:in6addr-condensed-text
syn keyword tl_keyword contained sys:is-label sys:l1-setq sys:l1-val sys:lambda-apply-transform
syn keyword tl_keyword contained sys:lambda-short-apply-list sys:lambda-too-few-args sys:lambda-too-many-args sys:lbind
syn keyword tl_keyword contained sys:lisp1-setq sys:lisp1-value sys:list-builder-flets sys:list-from-vm-desc
syn keyword tl_keyword contained sys:load-time-lit sys:loc sys:mac-env-flatten sys:make-anon-package
syn keyword tl_keyword contained sys:make-struct-lit sys:make-struct-type sys:mark-special sys:maybe-mov
syn keyword tl_keyword contained sys:misleading-ref-check sys:name-str sys:new-expander sys:new-type
syn keyword tl_keyword contained sys:obtain-impl sys:op-alpha-rename sys:op-expand sys:op-meta-p
syn keyword tl_keyword contained sys:open-compile-streams sys:operand-to-exp sys:operand-to-sym sys:opip-expand
syn keyword tl_keyword contained sys:opt-dash sys:opt-err sys:parse-compound-operand sys:parse-operand
syn keyword tl_keyword contained sys:parser-eof sys:parser-errors sys:path-access sys:path-examine
syn keyword tl_keyword contained sys:path-test sys:path-test-mode sys:pl-expand sys:placelet-1
syn keyword tl_keyword contained sys:print-backtrace sys:propagate-ancestor sys:prune-missing-inits sys:qquote
syn keyword tl_keyword contained sys:quasi sys:quasilist sys:r-s-let-expander sys:reg-expand-nongreedy
syn keyword tl_keyword contained sys:reg-optimize sys:register-opcode sys:register-simple-accessor sys:repl
syn keyword tl_keyword contained sys:rplaca sys:rplacd sys:rslotset sys:rt-defmacro
syn keyword tl_keyword contained sys:rt-defsymacro sys:rt-defun sys:rt-defvarl sys:rt-load-for
syn keyword tl_keyword contained sys:rt-pprof sys:set-hash-rec-limit sys:set-hash-str-limit sys:set-macro-ancestor
syn keyword tl_keyword contained sys:setq sys:setqf sys:shut-rd sys:shut-rdwr
syn keyword tl_keyword contained sys:shut-wr sys:slot-types sys:small-op-p sys:small-op-to-sym
syn keyword tl_keyword contained sys:splice sys:static-slot-types sys:str-inaddr-net-impl sys:struct-lit
syn keyword tl_keyword contained sys:switch sys:sym-clobber-expander sys:sym-delete-expander sys:sym-update-expander
syn keyword tl_keyword contained sys:system-symbol-p sys:test-clear sys:test-dec sys:test-inc
syn keyword tl_keyword contained sys:test-set sys:top-fb sys:top-mb sys:top-vb
syn keyword tl_keyword contained sys:tr* sys:trace sys:trace-canonicalize-name sys:trace-enter
syn keyword tl_keyword contained sys:trace-leave sys:trace-redefine-check sys:trfm sys:try-load
syn keyword tl_keyword contained sys:txr-case-impl sys:unquote sys:untrace sys:upenv
syn keyword tl_keyword contained sys:uw-block sys:uw-captured-block sys:uw-catch sys:uw-cont-copy
syn keyword tl_keyword contained sys:uw-eval sys:uw-expand sys:uw-fcall sys:uw-guard
syn keyword tl_keyword contained sys:uw-handle sys:uw-menv sys:var sys:vm-closure-desc
syn keyword tl_keyword contained sys:vm-closure-entry sys:vm-desc-bytecode sys:vm-desc-datavec sys:vm-desc-nlevels
syn keyword tl_keyword contained sys:vm-desc-nregs sys:vm-desc-symvec sys:vm-execute-toplevel sys:vm-make-desc
syn keyword tl_keyword contained sys:wdwrap sys:with-dyn-lib-check sys:with-lev-idx syslog
syn keyword tl_keyword contained system-package t tab0 tab1
syn keyword tl_keyword contained tab2 tab3 tabdly tagbody
syn keyword tl_keyword contained take take-until take-while tan
syn keyword tl_keyword contained tb tc tcdrain tcflow
syn keyword tl_keyword contained tcflush tcgetattr tciflush tcioff
syn keyword tl_keyword contained tcioflush tcion tcoflush tcooff
syn keyword tl_keyword contained tcoon tcsadrain tcsaflush tcsanow
syn keyword tl_keyword contained tcsendbreak tcsetattr tentative-def-exists tenth
syn keyword tl_keyword contained test-clear-dirty test-dirty test-neq-set-indent-mode test-set-indent-mode
syn keyword tl_keyword contained tf third throw throwf
syn keyword tl_keyword contained time time-fields-local time-fields-utc time-parse
syn keyword tl_keyword contained time-parse-local time-parse-utc time-string-local time-string-utc
syn keyword tl_keyword contained time-struct-local time-struct-utc time-t time-usec
syn keyword tl_keyword contained to tofloat tofloatz toint
syn keyword tl_keyword contained tointz tok tok-str tok-where
syn keyword tl_keyword contained tostop tostring tostringp tprint
syn keyword tl_keyword contained trace transpose tree-bind tree-case
syn keyword tl_keyword contained tree-find trie-add trie-compress trie-lookup-begin
syn keyword tl_keyword contained trie-lookup-feed-char trie-value-at trim-str true
syn keyword tl_keyword contained trunc trunc-rem truncate-stream tuples
syn keyword tl_keyword contained txr-case txr-exe-path txr-if txr-path
syn keyword tl_keyword contained txr-version txr-when typecase typedef
syn keyword tl_keyword contained typeof typep ubit uchar
syn keyword tl_keyword contained uid-t uint uint-ptr-t uint16
syn keyword tl_keyword contained uint32 uint64 uint8 ulong
syn keyword tl_keyword contained ulonglong umask umeth umethod
syn keyword tl_keyword contained uname unget-byte unget-char uni
syn keyword tl_keyword contained unintern union union-get union-in
syn keyword tl_keyword contained union-members union-out union-put uniq
syn keyword tl_keyword contained unique unless unquote unsetenv
syn keyword tl_keyword contained until until* untrace unum-carray
syn keyword tl_keyword contained unuse-package unuse-sym unwind-protect upcase-str
syn keyword tl_keyword contained upd update uref url-decode
syn keyword tl_keyword contained url-encode use use-package use-sym
syn keyword tl_keyword contained user-package ushort usl usleep
syn keyword tl_keyword contained uslot val vdiscard vec
syn keyword tl_keyword contained vec-carray vec-list vec-push vec-set-length
syn keyword tl_keyword contained vecref vector vector-list vectorp
syn keyword tl_keyword contained veof veol veol2 verase
syn keyword tl_keyword contained vintr vkill vlnext vm-fun-p
syn keyword tl_keyword contained vmin void vquit vreprint
syn keyword tl_keyword contained vstart vstop vsusp vswtc
syn keyword tl_keyword contained vt0 vt1 vtdly vtime
syn keyword tl_keyword contained vwerase w-continued w-coredump w-exitstatus
syn keyword tl_keyword contained w-ifcontinued w-ifexited w-ifsignaled w-ifstopped
syn keyword tl_keyword contained w-nohang w-stopsig w-termsig w-untraced
syn keyword tl_keyword contained wait wchar weave when
syn keyword tl_keyword contained whena whenlet where while
syn keyword tl_keyword contained while* whilet width width-check
syn keyword tl_keyword contained window-map window-mapdo window-mappend wint-t
syn keyword tl_keyword contained with-clobber-expander with-compilation-unit with-delete-expander with-dyn-lib
syn keyword tl_keyword contained with-gensyms with-hash-iter with-in-buf-stream with-in-string-byte-stream
syn keyword tl_keyword contained with-in-string-stream with-objects with-out-buf-stream with-out-string-stream
syn keyword tl_keyword contained with-out-strlist-stream with-resources with-slots with-stream
syn keyword tl_keyword contained with-update-expander wrap wrap* wstr
syn keyword tl_keyword contained wstr-d xcase yield yield-from
syn keyword tl_keyword contained zap zarray zero-fill zerop
syn keyword tl_keyword contained zip znew
syn match txr_nested_error "[^\t ]\+" contained
syn match txr_variable "\(@[ \t]*\)[*]\?[ \t]*[A-Za-z_][A-Za-z_0-9]*"
syn match txr_splicevar "@[ \t,*@]*[A-Za-z_][A-Za-z_0-9]*" contained
syn match txr_metanum "@\+[0-9]\+"
syn match txr_badesc "\\." contained
syn match txr_escat "\\@" contained
syn match txr_stresc "\\[abtnvfre\\ \n"`']" contained
syn match txr_numesc "\\x[0-9A-Fa-f]\+;\?" contained
syn match txr_numesc "\\[0-7]\+;\?" contained
syn match txr_regesc "\\[abtnvfre\\ \n/sSdDwW()\|.*?+~&%\[\]\-]" contained

syn match txr_error "#[^HSR]"

syn match txr_chr "#\\x[0-9A-Fa-f]\+"
syn match txr_chr "#\\o[0-7]\+"
syn match txr_chr "#\\[^ \t\nA-Za-z_0-9]"
syn match txr_chr "#\\[A-Za-z_0-9]\+"
syn match txr_ncomment ";.*"

syn match txr_hashbang "\%^#!.*"

syn match txr_dot "\." contained
syn match txr_ident "[A-Za-z_0-9!$%&*+\-<=>?\\_~]*[A-Za-z_!$%&*+\-<=>?\\_~^][A-Za-z_0-9!$%&*+\-<=>?\\_~^]*" contained
syn match tl_ident "[:@][A-Za-z_0-9!$%&*+\-<=>?\\_~^/]\+"
syn match txr_braced_ident "[:][A-Za-z_0-9!$%&*+\-<=>?\\_~^/]\+" contained
syn match tl_ident "[A-Za-z_0-9!$%&*+\-<=>?\\_~/]\+[A-Za-z_0-9!$%&*+\-<=>?\\_~^/#]*"
syn match txr_pnum "#[xob][+\-]\?[A-Za-z_0-9]\+" contains=txr_xnum,txr_bnum,txr_onum
syn match txr_xnum "#x[+\-]\?[0-9A-Fa-f]\+" containedin=txr_pnum contained
syn match txr_onum "#o[+\-]\?[0-7]\+" containedin=txr_pnum contained
syn match txr_bnum "#b[+\-]\?[01]\+" containedin=txr_pnum contained
syn match txr_num "[+\-]\?[0-9]\+\([^A-Za-z_0-9!$%&*+\-<=>?\\_~^/#]\|\n\)"me=e-1
syn match txr_badnum "[+\-]\?[0-9]*[.][0-9]\+\([eE][+\-]\?[0-9]\+\)\?[A-Za-z_!$%&*+\-<=>?\\_~^/#]\+"
syn match txr_num "[+\-]\?[0-9]*[.][0-9]\+\([eE][+\-]\?[0-9]\+\)\?\([^A-Za-z_0-9!$%&*+\-<=>?\\_~^/#]\|\n\)"me=e-1
syn match txr_num "[+\-]\?[0-9]\+\([eE][+\-]\?[0-9]\+\)\([^A-Za-z_0-9!$%&*+\-<=>?\\_~^/#]\|\n\)"me=e-1
syn match tl_ident ":"
syn match tl_splice "[ \t,]\|,[*]"

syn match txr_unquote "," contained
syn match txr_splice ",\*" contained
syn match txr_quote "'" contained
syn match txr_quote "\^" contained
syn match txr_dotdot "\.\." contained
syn match txr_metaat "@" contained
syn match txr_circ "#[0-9]\+[#=]"

syn match txr_buf_error "[^']" contained
syn match txr_buf_interior "\([0-9A-Fa-f][\n\t ]*[0-9A-Fa-f]\|[\n\t ]\+\)" contained

syn region txr_bracevar matchgroup=Delimiter start="@[ \t]*[*]\?{" matchgroup=Delimiter end="}" contains=txr_num,txr_pnum,tl_ident,tl_splice,tl_metanum,txr_metaat,txr_circ,txr_braced_ident,txr_dot,txr_dotdot,txr_string,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_regex,txr_quasilit,txr_chr,txr_nested_error
syn region txr_list matchgroup=Delimiter start="\(#[HSR]\?\)\?(" matchgroup=Delimiter end=")" contains=tl_keyword,txr_string,tl_regex,txr_num,txr_pnum,txr_badnum,tl_ident,txr_metanum,txr_ign_par,txr_ign_bkt,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_quasilit,txr_chr,txr_buf,txr_quote,txr_unquote,txr_splice,txr_dot,txr_dotdot,txr_metaat,txr_circ,txr_ncomment,txr_nested_error
syn region txr_bracket matchgroup=Delimiter start="\[" matchgroup=Delimiter end="\]" contains=tl_keyword,txr_string,tl_regex,txr_num,txr_pnum,txr_badnum,tl_ident,txr_metanum,txr_ign_par,txr_ign_bkt,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_quasilit,txr_chr,txr_buf,txr_quote,txr_unquote,txr_splice,txr_dot,txr_dotdot,txr_metaat,txr_circ,txr_ncomment,txr_nested_error
syn region txr_mlist matchgroup=Delimiter start="@[ \t^',]*(" matchgroup=Delimiter end=")" contains=tl_keyword,txr_string,tl_regex,txr_num,txr_pnum,txr_badnum,tl_ident,txr_metanum,txr_ign_par,txr_ign_bkt,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_quasilit,txr_chr,txr_buf,txr_quote,txr_unquote,txr_splice,txr_dot,txr_dotdot,txr_metaat,txr_circ,txr_ncomment,txr_nested_error
syn region txr_mbracket matchgroup=Delimiter start="@[ \t^',]*\[" matchgroup=Delimiter end="\]" contains=tl_keyword,txr_string,tl_regex,txr_num,txr_pnum,txr_badnum,tl_ident,txr_metanum,txr_ign_par,txr_ign_bkt,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_quasilit,txr_chr,txr_buf,txr_quote,txr_unquote,txr_splice,txr_dot,txr_dotdot,txr_metaat,txr_circ,txr_ncomment,txr_nested_error
syn region txr_string start=+#\?\*\?"+ end=+["\n]+ contains=txr_stresc,txr_numesc,txr_badesc
syn region txr_quasilit start=+#\?\*\?`+ end=+[`\n]+ contains=txr_splicevar,txr_metanum,txr_bracevar,txr_mlist,txr_mbracket,txr_escat,txr_stresc,txr_numesc,txr_badesc
syn region txr_regex start="/" end="[/\n]" contains=txr_regesc,txr_numesc,txr_badesc
syn region tl_regex start="#/" end="[/\n]" contains=txr_regesc,txr_numesc,txr_badesc
syn region txr_buf matchgroup=txr_buf start="#b'" end="'" contains=txr_buf_interior,txr_buf_error
syn region txr_ign_par matchgroup=Comment start="#;[ \t',]*\(#[HSR]\?\)\?(" matchgroup=Comment end=")" contains=txr_ign_par_interior,txr_ign_bkt_interior
syn region txr_ign_bkt matchgroup=Comment start="#;[ \t',]*\(#[HSR]\?\)\?\[" matchgroup=Comment end="\]" contains=txr_ign_par_interior,txr_ign_bkt_interior
syn region txr_ign_par_interior contained matchgroup=Comment start="(" matchgroup=Comment end=")" contains=txr_ign_par_interior,txr_ign_bkt_interior
syn region txr_ign_bkt_interior contained matchgroup=Comment start="\[" matchgroup=Comment end="\]" contains=txr_ign_par_interior,txr_ign_bkt_interior

hi def link txr_at Special
hi def link txr_atstar Special
hi def link txr_atat Special
hi def link txr_comment Comment
hi def link txr_ncomment Comment
hi def link txr_hashbang Preproc
hi def link txr_contin Preproc
hi def link txr_char String
hi def link txr_keyword Keyword
hi def link tl_keyword Type
hi def link txr_string String
hi def link txr_chr String
hi def link txr_quasilit String
hi def link txr_regex String
hi def link tl_regex String
hi def link txr_regdir String
hi def link txr_variable Identifier
hi def link txr_splicevar Identifier
hi def link txr_metanum Identifier
hi def link txr_escat Special
hi def link txr_stresc Special
hi def link txr_numesc Special
hi def link txr_regesc Special
hi def link txr_badesc Error
hi def link txr_ident Identifier
hi def link tl_ident Identifier
hi def link txr_num Number
hi def link txr_xnum Number
hi def link txr_bnum Number
hi def link txr_onum Number
hi def link txr_badnum Error
hi def link txr_pnum Error
hi def link txr_quote Special
hi def link txr_unquote Special
hi def link txr_splice Special
hi def link txr_dot Special
hi def link txr_dotdot Special
hi def link txr_metaat Special
hi def link txr_circ Special
hi def link txr_munqspl Special
hi def link tl_splice Special
hi def link txr_error Error
hi def link txr_nested_error Error
hi def link txr_buf String
hi def link txr_buf_interior String
hi def link txr_buf_error Error
hi def link txr_ign_par Comment
hi def link txr_ign_bkt_interior Comment
hi def link txr_ign_par_interior Comment
hi def link txr_ign_bkt Comment

let b:current_syntax = "lisp"

set lispwords=ado,alet,align,alignof,ap,append-each,append-each*,aret,array,arraysize,awk,bit,block,block*,bool,buf,buf-d,build,carray,caseq,caseq*,caseql,caseql*,casequal,casequal*,catch,catch*,catch**,collect-each,collect-each*,compile-only,cond,conda,condlet,cptr,dec,defex,deffi,deffi-cb,deffi-cb-unsafe,deffi-sym,deffi-type,deffi-var,define-accessor,define-modify-macro,define-param-expander,define-place-macro,defmacro,defmeth,defpackage,defparm,defparml,defplace,defset,defstruct,defsymacro,defun,defvar,defvarl,del,delay,do,dohash,doloop,doloop*,dotimes,each,each*,elemsize,elemtype,enum,enumed,equot,eval-only,ffi,flet,flip,for,for*,fun,gen,go,gun,handle,handle*,handler-bind,hlet,hlet*,ido,if,ifa,iflet,ignerr,ignwarn,in-package,ip,labels,lambda,lcons,let,let*,lnew*,load-for,load-time,lop,lset,mac-param-bind,macro-time,macrolet,mlet,new*,obtain,obtain*,obtain*-block,obtain-block,offsetof,op,pdec,pinc,placelet,placelet*,pop,pprof,prof,prog,prog*,prog1,progn,ptr,ptr-in,ptr-in-d,ptr-out,ptr-out-d,ptr-out-s,push,pushnew,ret,return,return-from,rlet,rslot,sbit,sizeof,slet,splice,struct,suspend,symacrolet,sys:abscond-from,sys:awk-fun-let,sys:awk-mac-let,sys:awk-redir,sys:catch,sys:compare-swap,sys:compile-in-toplevel,sys:conv,sys:defopcode,sys:defopcode-derived,sys:dlib-expr,sys:dvbind,sys:each-op,sys:expr,sys:fbind,sys:for-op,sys:l1-val,sys:lbind,sys:lisp1-value,sys:load-time-lit,sys:path-examine,sys:path-test,sys:placelet-1,sys:splice,sys:struct-lit,sys:switch,sys:test-clear,sys:test-dec,sys:test-inc,sys:test-set,sys:txr-case-impl,sys:unquote,sys:upenv,sys:var,sys:with-lev-idx,tagbody,tb,tc,trace,tree-bind,tree-case,txr-case,txr-if,txr-when,typecase,typedef,ubit,union,unless,unquote,until,until*,untrace,unwind-protect,upd,uref,when,whena,whenlet,while,while*,whilet,with-clobber-expander,with-compilation-unit,with-delete-expander,with-dyn-lib,with-gensyms,with-hash-iter,with-in-buf-stream,with-in-string-byte-stream,with-in-string-stream,with-objects,with-out-buf-stream,with-out-string-stream,with-out-strlist-stream,with-resources,with-slots,with-stream,with-update-expander,yield,yield-from,zap,zarray,znew,:method,:function,:init,:postinit,:fini
set comments=:\;\;\;,:\;\;,:\;
